import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';

import { MatButtonModule } from '@angular/material/button';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatIconModule } from '@angular/material/icon';
import { MatInputModule } from '@angular/material/input';
import { MatPaginatorModule } from '@angular/material/paginator';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { MatSortModule } from '@angular/material/sort';
import { MatSelectModule } from '@angular/material/select';
import { MatGridListModule } from '@angular/material/grid-list';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatTableModule } from '@angular/material/table';

import { TranslocoModule } from '@ngneat/transloco';

import { SharedModule } from 'app/shared/shared.module';

import { COMPONENTS } from './components';

import { partnerRecommendationRoutes } from './partner-recommendation.routing';

@NgModule({
  declarations: [COMPONENTS],
  imports: [
    TranslocoModule,
    SharedModule,
    RouterModule.forChild(partnerRecommendationRoutes),

    MatButtonModule,
    MatFormFieldModule,
    MatIconModule,
    MatInputModule,
    MatPaginatorModule,
    MatProgressBarModule,
    MatSortModule,
    MatSelectModule,
    MatGridListModule,
    MatCheckboxModule,
    MatTableModule,
  ],
})
export class PartnerRecommendationModule {}
