import { Injectable } from '@angular/core';
import {
  ActivatedRouteSnapshot,
  Resolve,
  Router,
  RouterStateSnapshot,
} from '@angular/router';
import { MemberSettlementSettingService } from 'app/modules/polyglot/member_settlement_setting/services/member_settlement_setting.service';
import {
  GetMemberSettlementSettingResponse,
  ListMemberSettlementSettingsResponse,
} from 'app/modules/proto/c2se/member_settlement_setting_pb';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root',
})
export class ListMemberSettlementsResolver implements Resolve<any> {
  /**
   * Constructor
   */
  constructor(
    private _router: Router,
    private __memberSettlementSettingService: MemberSettlementSettingService
  ) {}

  // -----------------------------------------------------------------------------------------------------
  // @ Public methods
  // -----------------------------------------------------------------------------------------------------

  /**
   * Resolver
   *
   * @param route
   * @param state
   */

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot
  ):
    | Observable<ListMemberSettlementSettingsResponse.Result>
    | Promise<ListMemberSettlementSettingsResponse.Result>
    | ListMemberSettlementSettingsResponse.Result {
    return this.__memberSettlementSettingService.listMemberSettlementSettings();
  }
}

@Injectable({
  providedIn: 'root',
})
export class MemberSettlementResolver implements Resolve<any> {
  /**
   * Constructor
   */
  constructor(
    private _router: Router,
    private __memberSettlementSettingService: MemberSettlementSettingService
  ) {}

  // -----------------------------------------------------------------------------------------------------
  // @ Public methods
  // -----------------------------------------------------------------------------------------------------

  /**
   * Resolver
   *
   * @param route
   * @param state
   */

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot
  ):
    | Observable<GetMemberSettlementSettingResponse.Result>
    | Promise<GetMemberSettlementSettingResponse.Result>
    | GetMemberSettlementSettingResponse.Result {
    let memberId = route.paramMap.get('id');
    if (!memberId) {
      console.error('user.resolver memberId is null');
    }
    return this.__memberSettlementSettingService.getMemberSettlementSetting(
      memberId!
    );
  }
}
